/* Infix notation calculator.  */
%name-prefix="zz"
%defines

%{
#define YYSTYPE double
#define YYDEBUG 1
#include <math.h>
#include <stdio.h>
#include<stdlib.h>
	
	
	%}
     
     /* Bison declarations.  */

     %token NUM
     %left '-' '+'
     %left '*' '/'
     %left NEG     /* negation--unary minus */
     %right '^'    /* exponentiation */
     
     %% /* The grammar follows.  */
     input:    /* empty */
             | input line
     ;
     
     line:     '\n'
             | exp '\n'{fprintf(stderr,"\nResult%d:\t%.10g", uv->instance,$1); }
             | error '\n' { yyerrok;                  }
     ;
     
     exp:      NUM                { $$ = $1;         }
             | exp '+' exp        { $$ = $1 + $3;    }
             | exp '-' exp        { $$ = $1 - $3;    }
             | exp '*' exp        { $$ = $1 * $3;    }
             | exp '/' exp        { $$ = $1 / $3;    }
             | '-' exp  %prec NEG { $$ = -$2;        }
             | exp '^' exp        { $$ = pow ($1, $3); }
             | '(' exp ')'        { $$ = $2;         }
             | 'x' {YYACCEPT}
     ;
     %%
