/* Reverse polish notation calculator.  */
%defines
%{
#define YYSTYPE double
#define YYDEBUG 1
#include <math.h>
#include <stdio.h>
#include<stdlib.h>
	%}
     
     %token NUM

     %% /* Grammar rules and actions follow.  */

     input:    /* empty */
             | input line
     ;
     
     line:     '\n'
             | exp '\n'      { fprintf (stderr,"\nResult%d: \t%.10g", uv->instance,$1); }
     ;
     
     exp:      NUM           { $$ = $1;           }
             | exp exp '+'   { $$ = $1 + $2;      }
             | exp exp '-'   { $$ = $1 - $2;      }
             | exp exp '*'   { $$ = $1 * $2;      }
             | exp exp '/'   { $$ = $1 / $2;      }
              /* Exponentiation */
             | exp exp '^'   { $$ = pow ($1, $2); }
              /* Unary minus    */
             | exp 'n'       { $$ = -$1;          }
             | 'x' {YYACCEPT}
     ;
     %%
